%define anolis_release 1

Name:           libmicrohttpd
Version:        0.9.75
Release:        %{anolis_release}%{?dist}
Epoch:          1
Summary:        Lightweight library for embedding a webserver in applications
License:        LGPLv2+
URL:            http://www.gnu.org/software/libmicrohttpd/
Source0:        https://ftp.gnu.org/gnu/libmicrohttpd/%{name}-%{version}.tar.gz
Patch0:         gnutls-utilize-system-crypto-policy.patch

BuildRequires:  texinfo
BuildRequires:  gnutls-devel
BuildRequires:  doxygen graphviz
BuildRequires:  make

%description
GNU libmicrohttpd is a small C library that is supposed to make it
easy to run an HTTP server as part of another application.
Key features that distinguish libmicrohttpd from other projects are:

* C library: fast and small
* API is simple, expressive and fully reentrant
* Implementation is http 1.1 compliant
* HTTP server can listen on multiple ports
* Support for IPv6
* Support for incremental processing of POST data
* Creates binary of only 25k (for now)
* Three different threading models

%package devel
Summary:        Development files for libmicrohttpd
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description devel
Development files for libmicrohttpd

%package doc
Summary:        Documentation for libmicrohttpd
Requires:       %{name} = %{epoch}:%{version}-%{release}
BuildArch:      noarch

%description doc
Doxygen documentation for libmicrohttpd and some example source code

%prep
%autosetup -n %{name}-%{version} -p1

%build
%configure --disable-static --with-gnutls --enable-https=yes
%make_build
make -C doc/doxygen full

%check
%make_build check

%install
%make_install

rm -f %{buildroot}%{_bindir}/demo

# Install some examples in /usr/share/doc/libmicrohttpd-doc/examples
mkdir examples
install -m 644 src/examples/*.c examples
install -m 644 doc/examples/*.c examples

%generate_compatibility_deps

%files
%license COPYING
%dir %{abidir}
%{_libdir}/libmicrohttpd.so.*
%{abidir}/libmicrohttpd.dump

%files devel
%doc examples
%{_includedir}/microhttpd.h
%{_libdir}/libmicrohttpd.so
%{_libdir}/pkgconfig/libmicrohttpd.pc
%{_infodir}/libmicrohttpd.info.*
%{_infodir}/libmicrohttpd-tutorial.info.*
%{_infodir}/libmicrohttpd_performance_data.png.zst
%{_mandir}/man3/libmicrohttpd.3.*

%files doc
%doc doc/doxygen/html
%doc AUTHORS README ChangeLog NEWS

%changelog
* Thu Jan 05 2023 happy_orange <songnannan@linux.alibaba.com> - 1:0.9.75-1
- package init from upstream
